<?php
namespace Ak\Lib\File;

/**
 * Predstavlja datoteku.
 *
 * @package Ak\Lib\File
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/lib-file
 */
interface FileInterface
{
    /**
     * Vraća sadržaj datoteke.
     *
     * @return string
     */
    public function getContents(): string;

    /**
     * Vraća MD5 hash ove datoteke.
     *
     * @return string
     */
    public function getMd5Hash(): string;

    /**
     * Vraća mime-type ove datoteke.
     *
     * @return string
     */
    public function getMimeType(): string;

    /**
     * Vraća ime ove datoteke.
     *
     * @return string|null
     */
    public function getName(): ?string;

    /**
     * Postavlja ime ove datoteke.
     *
     * @param string $name
     */
    public function setName(string $name): void;

    /**
     * Vraća stream za ovu datoteku.
     *
     * @return resource
     */
    public function getStream();
}